package com.example.basketballmatchmanager;

import java.util.ArrayList;
import com.example.basketballmatchmanager.R;
import com.example.basketballmatchmanager.db.Club;
import com.example.basketballmatchmanager.db.Item;
import com.example.basketballmatchmanager.db.Team;
import android.app.Activity;
import android.content.Intent;
import android.content.res.TypedArray;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.Spinner;

public class EditClubScreen extends Activity implements OnClickListener, OnItemClickListener, OnItemSelectedListener {
	
	private Club myClub;
	private Team myTeam;
	private Spinner sProvince;
	private Spinner sTown;
	private EditText txtClub;
	private EditText txtDesc;
	private EditText txtCourt;
    private ImageView btnSave;
    private ImageView btnCancel;
    private ImageView btnCreateTeam;
    private TextView txtTeamsClub;
    private ListView lstTeamsClub;
    private String strTown;
    private int idClub;
    private Intent i;
        	
	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.club);
		
		btnCreateTeam = (ImageView) findViewById(R.id.ImageView30);
		btnCreateTeam.setOnClickListener(this);
		btnSave = (ImageView) findViewById(R.id.ImageView07);
		btnSave.setOnClickListener(this);
		btnCancel = (ImageView) findViewById(R.id.ImageView08);
		btnCancel.setOnClickListener(this);
				
		txtClub = (EditText) findViewById(R.id.txtClub);
		txtDesc = (EditText) findViewById(R.id.txtDescription);		
		txtCourt = (EditText) findViewById(R.id.txtCourt);
		txtTeamsClub = (TextView) findViewById(R.id.lbRegisteredTeams);
		lstTeamsClub = (ListView) findViewById(R.id.listViewTeamsClub);
				
		//Es plena el Spinner amb els noms de les provincies d'Espanya.
		sProvince = (Spinner) findViewById(R.id.sProvince);
		ArrayAdapter<CharSequence> adapter2 = ArrayAdapter.createFromResource(this, R.array.provincias, android.R.layout.simple_spinner_item);
		adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		this.sProvince.setAdapter(adapter2);
		this.sProvince.setOnItemSelectedListener(this);
		
		this.sTown = (Spinner) findViewById(R.id.sTown);
		this.sTown.setOnItemSelectedListener(this);
		
		Bundle b1 = getIntent().getExtras();
		if (b1 != null) {
			int idClub = b1.getInt("id");
			Club myClub = new Club(this);
			myClub.openConnection();
			Cursor cursor1 = myClub.getClubForId(idClub);

			if (cursor1.moveToFirst()) {
				txtClub.setText(cursor1.getString(1));		
				txtDesc.setText(cursor1.getString(2));
				sProvince.setSelection(getIndex(sProvince, cursor1.getString(3)));
				//sTown.setSelection(getIndex(sTown, cursor.getString(4)));
				strTown = cursor1.getString(4);
				txtCourt.setText(cursor1.getString(5));
				
				myTeam = new Team (this);
				myTeam.openConnection();
				
				//Recupera els registres e imprimeix al listview
				Cursor cursor2 = myTeam.getTeamForClub(idClub);
				
				if (cursor2.getCount()>0) {
					ArrayList<Item> listData = myTeam.getListItem(cursor2);
					ArrayAdapter<Item> adaptador1 = new ArrayAdapter<Item>(this, android.R.layout.simple_list_item_1, listData);
					lstTeamsClub.setAdapter(adaptador1);
					lstTeamsClub.setOnItemClickListener(this);
					myTeam.closeConnection();
					
					txtTeamsClub.setVisibility(View.VISIBLE);
					btnCreateTeam.setVisibility(View.VISIBLE);
					lstTeamsClub.setVisibility(View.VISIBLE);
				}
				cursor2.close();
				cursor1.close();
				myClub.closeConnection();
			}
		}
		else {
			txtTeamsClub.setVisibility(View.INVISIBLE);
			btnCreateTeam.setVisibility(View.INVISIBLE);
			lstTeamsClub.setVisibility(View.INVISIBLE);
			sProvince.setSelection(getIndex(sProvince, "Barcelona"));
		}
	}
	
	private int getIndex(Spinner spinner, String myString){
		int index = 0;
		 
		for (int i=0;i<spinner.getCount();i++){
			if (spinner.getItemAtPosition(i).equals(myString)){
				index = i;
			}
		}
		return index;
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public void onClick(View v) {
		switch ( v.getId() ) 
		{
			// Bot de guardar dades
			case R.id.ImageView07: 
				
				myClub = new Club (this, txtClub.getText().toString(), txtDesc.getText().toString(), 
						sProvince.getSelectedItem().toString(), sTown.getSelectedItem().toString(),
						txtCourt.getText().toString(), "User1");
				myClub.openConnection();
				
				//Realitza un INSERT a la base de dades
				if (myClub.addRegister()) {
					Log.i("SQLite", "Nou registre insertat");
					Toast.makeText(getBaseContext(), R.string.InfoClub, Toast.LENGTH_LONG).show();	
					
					i = new Intent(EditClubScreen.this, MainActivity.class);
					startActivity(i);
				}
				else {
					Toast.makeText(getBaseContext(), R.string.InfoErrorIntro, Toast.LENGTH_SHORT).show();
				}
				
				myClub.closeConnection();
				break;
				
			case R.id.ImageView08:
				// Torna a la pantalla d'inici (ActivityMain)
				i = new Intent( EditClubScreen.this, MainActivity.class );
				startActivity(i);	
				break;
				
			case R.id.ImageView30 : 
				// Accedeix a la pantalla d'equips d'un club.
				i = new Intent(EditClubScreen.this, EditTeamScreen.class);
				Bundle b2 = new Bundle();
				b2.putString("mode","CREATE");
				b2.putInt("idClub", idClub);
				b2.putString("club", txtClub.getText().toString());
				i.putExtras(b2);
				startActivity(i);	
				break;
		}
	}

	@Override
	public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
		// TODO Auto-generated method stub
		
		switch (parent.getId()) {
			
			case R.id.sProvince:
				// Retrieves an array
				TypedArray arrayLocalidades = getResources().obtainTypedArray(R.array.array_provincia_a_localidades);
				CharSequence[] localidades = arrayLocalidades.getTextArray(position);
				arrayLocalidades.recycle();
				// Create an ArrayAdapter using the string array and a default spinner layout
				ArrayAdapter<CharSequence> adapter2 = new ArrayAdapter<CharSequence>(this, android.R.layout.simple_spinner_item,	android.R.id.text1, localidades);
				// Specify the layout to use when the list of choices appears
				adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
				// Apply the adapter to the spinner
				this.sTown.setAdapter(adapter2);
				this.sTown.setSelection(getIndex(sTown, strTown));
				break;

			case R.id.sTown:
				break;
		}
	}

	@Override
	public void onNothingSelected(AdapterView<?> parent) {
		// Callback method to be invoked when the selection disappears from this
		// view. The selection can disappear for instance when touch is
		// activated or when the adapter becomes empty.
	}

	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position,	long id) {
		// TODO Auto-generated method stub
		
		Object object  = parent.getAdapter().getItem(position);
		String resultado = ((Item)object).getId();
		
		//Executa una nova activitat
		Intent i = new Intent(EditClubScreen.this, EditTeamScreen.class );	
		Bundle b3 = new Bundle();
		b3.putString("mode","REGISTER");
		b3.putInt("idTeam", Integer.valueOf(resultado));
		b3.putString("club", txtClub.getText().toString());
		i.putExtras(b3);
		startActivity(i);
	}
	
	}
