package com.example.basketballmatchmanager;

import com.example.basketballmatchmanager.R;
import com.example.basketballmatchmanager.db.League;
import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class EditLeagueScreen extends Activity implements OnClickListener{
	
	private League myLeague;
	private Spinner sLevel;
	private Spinner sComunity;
	private EditText txtName;
    private EditText txtGroup;
    private EditText txtDescription;
    private TextView lbComunity;
    private CheckBox chWomen;    
    private RadioGroup radFed;
    private RadioButton rSpaFed;
    private RadioButton rComFed;
    private ImageView btnSave;
    private ImageView btnCancel;
    private Intent i;
    	
	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.league);
		
		btnSave = (ImageView) findViewById(R.id.ImageView05);
		btnSave.setOnClickListener(this);
		btnCancel = (ImageView) findViewById(R.id.ImageView06);
		btnCancel.setOnClickListener(this);
		
		txtName = (EditText) findViewById(R.id.txtName);		
		txtGroup = (EditText) findViewById(R.id.txtGroup);
		txtDescription = (EditText) findViewById(R.id.txtDescription);
		chWomen = (CheckBox) findViewById(R.id.chWomen);
		radFed = (RadioGroup) findViewById(R.id.gpFederation);
		rSpaFed = (RadioButton) findViewById(R.id.rSpaFed);
		rSpaFed.setOnClickListener(this);
		rComFed = (RadioButton) findViewById(R.id.rComFed);
		rComFed.setOnClickListener(this);
		lbComunity = (TextView) findViewById(R.id.lbComunity);
	
		//Es plena el Spinner amb els noms de les categories.
		String[] level = getResources().getStringArray(R.array.Basketlevel);
		sLevel = (Spinner) findViewById(R.id.sLevel);
		ArrayAdapter<String> adapter2 = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, level);
		sLevel.setAdapter(adapter2);
		
		//Es plena el Spinner amb els noms de les comunitats.
		String[] comunity = getResources().getStringArray(R.array.Fedcomunity);
		sComunity = (Spinner) findViewById(R.id.sComunity);
		ArrayAdapter<String> adapter3 = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, comunity);
		sComunity.setAdapter(adapter3);
		
		Bundle listItemPushed = getIntent().getExtras();
		if (listItemPushed != null) {
			int id = listItemPushed.getInt("id");
			myLeague = new League(this);
			myLeague.openConnection();
			Cursor cursor = myLeague.getLeagueForId(id);
			
			if (cursor.moveToFirst()) {
				txtName.setText(cursor.getString(1));		
				txtGroup.setText(cursor.getString(2));
				txtDescription.setText(cursor.getString(3));
				sLevel.setSelection(getIndex(sLevel, cursor.getString(4)));
				chWomen.setChecked((Integer.parseInt(cursor.getString(5))==0)?false:true);
				rSpaFed.setChecked((Integer.parseInt(cursor.getString(6))==0)?false:true);
				rComFed.setChecked((Integer.parseInt(cursor.getString(6))==0)?true:false);				
				if (cursor.getString(7).equals("")) {
					lbComunity.setVisibility(View.INVISIBLE);
					sComunity.setVisibility(View.INVISIBLE);
				}
				else {
					lbComunity.setVisibility(View.VISIBLE);
					sComunity.setVisibility(View.VISIBLE);
					sComunity.setSelection(getIndex(sComunity, cursor.getString(7)));					
				}
			}
			cursor.close();
			myLeague.closeConnection();
		}
		else {
			sLevel.setSelection(getIndex(sLevel, "Senior"));
			sComunity.setSelection(getIndex(sComunity, "Catalunya"));
		}
	}
	
	private int getIndex(Spinner spinner, String myString){
		int index = 0;
		 
		for (int i=0;i<spinner.getCount();i++){
			if (spinner.getItemAtPosition(i).equals(myString)){
				index = i;
			}
		}
		return index;
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public void onClick(View v) {
		switch ( v.getId() ) 
		{
			case R.id.rSpaFed :
				
				lbComunity.setVisibility(View.INVISIBLE);
				sComunity.setVisibility(View.INVISIBLE);
				break;
				
			case R.id.rComFed :
				
				lbComunity.setVisibility(View.VISIBLE);
				sComunity.setVisibility(View.VISIBLE);
				break;
				
			// Bot de guardar dades
			case R.id.ImageView05 : 
				
				//int radioButtonID = radFed.getCheckedRadioButtonId();
				//View radioButton = radFed.findViewById(radioButtonID);
				//Comprobem quin dels dos optionButton s el marcat.
				View radioButton = radFed.findViewById(radFed.getCheckedRadioButtonId());
				int index = radFed.indexOfChild(radioButton);
				
				myLeague = new League (this, txtName.getText().toString(), txtGroup.getText().toString(), txtDescription.getText().toString(), 
						sLevel.getSelectedItem().toString(), (chWomen.isChecked())?true:false,
						(index==0)?true:false, sComunity.getSelectedItem().toString(), "User1");
				myLeague.openConnection();
				
				//Realitza un INSERT a la base de dades
				if (myLeague.addRegister()) {
					Log.i("SQLite", "Nou registre insertat");
					Toast.makeText(getBaseContext(), R.string.InfoLeague, Toast.LENGTH_LONG).show();
					i = new Intent(EditLeagueScreen.this, MainActivity.class);
					startActivity(i);
				}
				else {
					Toast.makeText(getBaseContext(), R.string.InfoErrorIntro, Toast.LENGTH_SHORT).show();
				}
				myLeague.closeConnection();
				break;
				
			case R.id.ImageView06 :
				// Torna a la pantalla d'inici (MainActivity)
				i = new Intent( EditLeagueScreen.this, MainActivity.class );
				startActivity(i);	
				break;
		}
	}
	}
