package com.example.basketballmatchmanager;

import java.util.List;

import com.example.basketballmatchmanager.R;
import com.example.basketballmatchmanager.db.Club;
import com.example.basketballmatchmanager.db.Item;
import com.example.basketballmatchmanager.db.League;
import com.example.basketballmatchmanager.db.Match;
import com.example.basketballmatchmanager.db.Team;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.DatePicker;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.SpinnerAdapter;
import android.widget.TextView;

public class EditMatchScreen extends Activity implements OnClickListener{
	
	private Spinner sLeague;
	private Spinner sSeason;
	private Spinner sLocal;
	private Spinner sVisitor;
	private TextView txtCourt;
	private TextView txtMatchDate;
	private TextView txtMatchHour;
	private CheckBox chFinished;
    private Button btnInit;	
    private ImageView btnSave;
    private ImageView btnCancel;
    private Intent i;
    
	//Variables para fecha
    private int mYear;
    private int mMonth;
    private int mDay;
    
	//DatePickerDialog
	private DatePickerDialog.OnDateSetListener mDateSetListener = new DatePickerDialog.OnDateSetListener() {
		@Override
		public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
			mYear = year;
		    mMonth = monthOfYear;
		    mDay = dayOfMonth;		             
		    txtMatchDate.setText(((mDay<10)?"0"+mDay:mDay) + "/" + ((mMonth<10)?"0"+mMonth:mMonth) + "/" + mYear);
		}
    };
    	
	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.match);
		
		btnInit = (Button) findViewById(R.id.Button01);
		btnInit.setOnClickListener(this);
		btnSave = (ImageView) findViewById(R.id.ImageView13);
		btnSave.setOnClickListener(this);
		btnCancel = (ImageView) findViewById(R.id.ImageView14);
		btnCancel.setOnClickListener(this);
	
		txtCourt = (TextView) findViewById(R.id.txtCourt);
		txtMatchDate = (TextView) findViewById(R.id.txtDate);
		txtMatchDate.setOnClickListener(this);
		txtMatchHour = (TextView) findViewById(R.id.txtHour);
		chFinished = (CheckBox) findViewById( R.id.chFinishedMatch);
		
		Bundle b = getIntent().getExtras();
		if (b != null) {
		
			//Carrega Spinner amb Lligues disponibles
			League myLeague = new League(this);
			myLeague.openConnection();
		    List<Item> labels1 = myLeague.getSpinnerLeague();
		    sLeague = (Spinner) findViewById(R.id.sLeagues);
		    // Creating adapter for spinner  
		    ArrayAdapter<Item> adapter1 = new ArrayAdapter<Item>(this,android.R.layout.simple_spinner_item, labels1);  
		    // Drop down layout style - list view with radio button  
		    adapter1.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);  
		    // attaching data adapter to spinner  
		    sLeague.setAdapter(adapter1); 		        
		    myLeague.closeConnection();
		    
		    /******************************************************************************************
		    /*Aquesta part de codi esta pensada per carregar els equips en funci de la lliga escollida
		    /******************************************************************************************
		    sLeague.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
		        public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) { 
		    		
		        	Object object  = adapterView.getSelectedItem();
		    		String resultado = ((Item)object).getId();
		        }
	
				@Override
				public void onNothingSelected(AdapterView<?> parent) {
					// TODO Auto-generated method stub
				} 
		    });*/
		    
			String[] season = getResources().getStringArray(R.array.Yearseason);
			sSeason = (Spinner) findViewById(R.id.sSeasons);
			ArrayAdapter<String> adapter2 = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, season);
			sSeason.setAdapter(adapter2);		
		    sSeason.setSelection(getIndex(sSeason, "14/15"));
	
			//Carrega Spinner amb els Equiops disponibles
			Team myTeam = new Team(this);
			myTeam.openConnection();
		    List<Item> labels2 = myTeam.getSpinnerTeam();
		    sLocal = (Spinner) findViewById(R.id.sLocal);
		    sVisitor = (Spinner) findViewById(R.id.sVisitor);
		    // Creating adapter for spinner  
		    ArrayAdapter<Item> adapter3 = new ArrayAdapter<Item>(this,android.R.layout.simple_spinner_item, labels2);  
		    // Drop down layout style - list view with radio button  
		    adapter3.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);  
		    // attaching data adapter to spinner  
		    sLocal.setAdapter(adapter3);
		    sVisitor.setAdapter(adapter3);
		    myTeam.closeConnection();
	    


			int idMatch = b.getInt("id");
			Match myMatch = new Match(this);
			myMatch.openConnection();
			Cursor cursor = myMatch.getMatchForId(idMatch);

			if (cursor.moveToFirst()) {
				/*
				sLeague.setSelection(getIndex(sLeague, cursor.getString(1)));
				sSeason.setSelection(getIndex(sSeason, cursor.getString(2)));
				sLocal.setSelection(getIndex(sLocal, cursor.getString(3)));
				sVisitor.setSelection(getIndex(sVisitor, cursor.getString(4)));
				*/
				sLeague.setSelection(getIndex(sLeague, "ACB"));
				sSeason.setSelection(getIndex(sSeason, cursor.getString(2)));
				sLocal.setSelection(getIndex(sLocal, "Regal Barcelona"));
				sVisitor.setSelection(getIndex(sVisitor, "La Bruixa Dor"));
								
				Club myClub = new Club(this);
				myClub.openConnection();
				txtCourt.setText(myClub.getCourt(cursor.getString(3)));
				myClub.closeConnection();
				txtMatchDate.setText(cursor.getString(5));
				//txtMatchHour.setText(cursor.getString(5));
				chFinished.setChecked((Integer.parseInt(cursor.getString(6))==0)?false:true);
			}
		}
	}
	
	private int getIndex(Spinner spinner, String myString){
		int index = 0;
		 
		for (int i=0;i<spinner.getCount();i++){
			if (spinner.getItemAtPosition(i).equals(myString)){
				index = i;
			}
		}
		return index;
	}
	
	/**
	 * Metodo para mostrar un DatePickerDialog
	 * */
	public void viewDatePicker()
	{
		DatePickerDialog d = new DatePickerDialog( this , mDateSetListener, mYear, mMonth, mDay );
		d.show();
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public void onClick(View v) {
		switch ( v.getId() ) 
		{
		case R.id.Button01 :
			// Va a la pantalla de PARTIT EN CURS 
			i = new Intent(EditMatchScreen.this, EditScoreScreen.class);
			startActivity(i);	
			break;
		
			// Bot de guardar dades
			case R.id.ImageView13 : 
				
				break;
				
			case R.id.ImageView14 :
				// Torna a la pantalla d'inici (ActivityMain)
				i = new Intent(EditMatchScreen.this, MainActivity.class);
				startActivity(i);	
				break;

			case R.id.txtDate:
				// Carrega i mostra DataPicker
				viewDatePicker(); 
				break;				
		}
	}
	}
