package com.example.basketballmatchmanager;

import com.example.basketballmatchmanager.R;
import com.example.basketballmatchmanager.db.Club;
import com.example.basketballmatchmanager.db.Player;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.CheckBox;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import java.util.Calendar;

public class EditPlayerScreen extends Activity implements OnClickListener{
	
	private Player myPlayer; 
	private EditText txtName;
	private EditText txtSurname;
	private TextView txtBirthDate;
	private CheckBox chNation;
    private RadioButton radMan;
    private RadioButton radWoman;    
    private ImageView btnSave;
    private ImageView btnCancel;
    private Intent i;
    
	//Variables para fecha
    private int mYear;
    private int mMonth;
    private int mDay;
    
	//DatePickerDialog
	private DatePickerDialog.OnDateSetListener mDateSetListener = new DatePickerDialog.OnDateSetListener() {
		@Override
		public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
			mYear = year;
		    mMonth = monthOfYear;
		    mDay = dayOfMonth;		             
		    txtBirthDate.setText(((mDay<10)?"0"+mDay:mDay) + "/" + mMonth + "/" + mYear);
		}
    };
    	
	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.player);
		
		btnSave = (ImageView) findViewById(R.id.ImageView11);
		btnSave.setOnClickListener(this);
		btnCancel = (ImageView) findViewById(R.id.ImageView12);
		btnCancel.setOnClickListener(this);

		txtName = (EditText) findViewById(R.id.txtName);
		txtSurname = (EditText) findViewById(R.id.txtSurname);
		txtBirthDate = (TextView) findViewById(R.id.txtBirthDate);
		txtBirthDate.setOnClickListener(this);
		radMan = (RadioButton) findViewById(R.id.rMan);
		radWoman = (RadioButton) findViewById(R.id.rWoman);
		chNation = (CheckBox) findViewById(R.id.chNation);
		
		//Obtiene fecha actual y coloca en el textview
		Calendar c = Calendar.getInstance();
        mYear = c.get(Calendar.YEAR);
        mMonth = c.get(Calendar.MONTH);
        mDay = c.get(Calendar.DAY_OF_MONTH);        
        //muestra la fecha de la forma 00/00/0000
        txtBirthDate.setText( ((mDay<10)?"0"+mDay:mDay) + "/" + ((mMonth<10)?"0"+mMonth:mMonth) + "/" + mYear );
        
		Bundle b = getIntent().getExtras();
		if (b != null) {
			int idPlayer = b.getInt("id");
			myPlayer = new Player(this);
			myPlayer.openConnection();
			Cursor cursor = myPlayer.getPlayerForId(idPlayer);

			if (cursor.moveToFirst()) {
				txtName.setText(cursor.getString(1));		
				txtSurname.setText(cursor.getString(2));
				txtBirthDate.setText(cursor.getString(3));
				radMan.setChecked(cursor.getString(4).equals("Hombre"));
				radWoman.setChecked(cursor.getString(4).equals("Mujer"));
				chNation.setChecked((Integer.parseInt(cursor.getString(5))==0)?false:true);
			}
		}
	}
	
	/**
	 * Metodo para mostrar un DatePickerDialog
	 * */
	public void viewDatePicker()
	{
		DatePickerDialog d = new DatePickerDialog(this, mDateSetListener, mYear, mMonth, mDay);
		d.show();
	}	
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) 
		{
			// Bot de guardar dades
			case R.id.ImageView11 : 
				
				break;
				
			case R.id.ImageView12 :
				// Torna a la pantalla d'inici (ActivityMain)
				i = new Intent(EditPlayerScreen.this, MainActivity.class);
				startActivity(i);	
				break;
				
			case R.id.txtBirthDate:
				// Carrega i mostra DataPicker
				viewDatePicker(); 
				break;
		}
	}
	}
