package com.example.basketballmatchmanager;

import java.util.List;
import com.example.basketballmatchmanager.R;
import com.example.basketballmatchmanager.db.Item;
import com.example.basketballmatchmanager.db.Team;
import com.example.basketballmatchmanager.db.League;
import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.Toast;
import android.widget.Spinner;
import android.widget.TextView;

public class EditTeamScreen extends Activity implements OnClickListener {
	
	private Team myTeam;
	private League myLeague;
	private Spinner sLeague;
	private Spinner sSeason;
	private Spinner sLevel;
	private TextView txtClub;
	private EditText txtTeam;
    private CheckBox chWomen;
    private Button btnRegister;
    private LinearLayout layLeague;
    private LinearLayout laySeason;
    private ImageView btnSave;
    private ImageView btnCancel;
    private String clubName;
    private String mode;
    private int idClub;
    private int idTeam;
    private Intent i;
    	
	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.team);
		
		btnRegister = (Button) findViewById(R.id.Button01);
		btnRegister.setOnClickListener(this);
		btnSave = (ImageView) findViewById(R.id.ImageView09);
		btnSave.setOnClickListener(this);
		btnCancel = (ImageView) findViewById(R.id.ImageView10);
		btnCancel.setOnClickListener(this);
		
		txtClub = (TextView) findViewById(R.id.txtClub);
		txtTeam = (EditText) findViewById(R.id.txtTeam);
		chWomen = (CheckBox) findViewById(R.id.chWomenTeam);
		layLeague = (LinearLayout) findViewById(R.id.layLeague);
		laySeason = (LinearLayout) findViewById(R.id.laySeason);
				
		//Es plena el Spinner amb els noms de les categories.
		String[] level = getResources().getStringArray(R.array.Basketlevel);
		sLevel = (Spinner) findViewById(R.id.sLevel);
		ArrayAdapter<String> adapter1 = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, level);
		sLevel.setAdapter(adapter1);		
		sLevel.setSelection(getIndex(sLevel, "Senior"));
		
		Bundle b1 = getIntent().getExtras();
		if (b1 != null) {
			if (b1.getString("mode").equals("CREATE")) { 	
				mode = b1.getString("mode");
				idClub = b1.getInt("idClub");
				clubName = b1.getString("club");
				txtClub.setText(clubName);
			}
			else {
				mode = b1.getString("mode");
				idTeam = b1.getInt("idTeam");
				clubName = b1.getString("club");
				myTeam = new Team(this);
				myTeam.openConnection();
				Cursor cursor = myTeam.getTeamForId(idTeam);
				
				if (cursor.moveToFirst()) {
					txtClub.setText(clubName);
					txtTeam.setText(cursor.getString(2));		
					sLevel.setSelection(getIndex(sLevel, cursor.getString(3)));
					chWomen.setChecked((Integer.parseInt(cursor.getString(4))==0)?false:true);
					btnRegister.setVisibility(View.VISIBLE);
				}
				cursor.close();
				myTeam.closeConnection();
			}
		}
	}
	
	private int getIndex(Spinner spinner, String myString){
		int index = 0;
		 
		for (int i=0;i<spinner.getCount();i++){
			if (spinner.getItemAtPosition(i).equals(myString)){
				index = i;
			}
		}
		return index;
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public void onClick(View v) {
		switch ( v.getId() ) 
		{
			// Bot Inscriure equip en una lliga.
			case R.id.Button01:
				
				layLeague.setVisibility(View.VISIBLE);
				laySeason.setVisibility(View.VISIBLE);
				sLeague = (Spinner) findViewById(R.id.sLeagues);
					
				myLeague = new League(this);
				myLeague.openConnection();
			    List<Item> labels = myLeague.getSpinnerLeague(sLevel.getSelectedItem().toString(), 
			       		(chWomen.isChecked())?"1":"0");  
			        
			    // Creating adapter for spinner  
			    ArrayAdapter<Item> dataAdapter = new ArrayAdapter<Item>(this,android.R.layout.simple_spinner_item, labels);  
			   
			    // Drop down layout style - list view with radio button  
			    dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);  
			    
			    // attaching data adapter to spinner  
			    sLeague.setAdapter(dataAdapter); 		        
			    myLeague.closeConnection();
			    
				String[] season = getResources().getStringArray(R.array.Yearseason);
				sSeason = (Spinner) findViewById(R.id.sSeasons);
				ArrayAdapter<String> adapter2 = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, season);
				sSeason.setAdapter(adapter2);		
			    sSeason.setSelection(getIndex(sSeason, "14/15"));
			    
				break;
				
			// Bot de guardar dades
			case R.id.ImageView09: 
				
				if (mode.equals("CREATE")) { 
					myTeam = new Team (this, idClub, txtTeam.getText().toString(), sLevel.getSelectedItem().toString(), 
							(chWomen.isChecked())?true:false, "User1");
					myTeam.openConnection();
					
					//Realitza un INSERT a la base de dades
					if (myTeam.addRegister()) {
						Log.i("SQLite", "Nou registre insertat");
						Toast.makeText(getBaseContext(), R.string.InfoTeam, Toast.LENGTH_LONG).show();
						Bundle b2 = new Bundle();
						b2.putInt("id", idClub);
						i = new Intent(EditTeamScreen.this, EditClubScreen.class);
						i.putExtras(b2);
						startActivity(i);
					}
					else {
						Toast.makeText(getBaseContext(), R.string.InfoErrorIntro, Toast.LENGTH_SHORT).show();
					}
					myTeam.closeConnection();
				}
				/*
				else {
					
					myTeam = new Team (this);
					myTeam.openConnection();
					
					Object object  = sLeague.getSelectedItem();
					String resultado = ((Item)object).getId();
					
					//Realitza un INSERT a la base de dades
					if (myTeam.addRegisteredTeam(Integer.toString(idTeam), sSeason.getSelectedItem().toString(), resultado, "user1")) {
						Log.i("SQLite", "Nou registre insertat");
						Toast.makeText(getBaseContext(), R.string.InfoTeam, Toast.LENGTH_LONG).show();
						Bundle b2 = new Bundle();
						b2.putInt("id", idClub);
						i = new Intent(EditTeamScreen.this, EditClubScreen.class);
						i.putExtras(b2);
						startActivity(i);
					}
					else {
						Toast.makeText(getBaseContext(), R.string.InfoErrorIntro, Toast.LENGTH_SHORT).show();
					}
				}*/
					
				break;
				
			case R.id.ImageView10:
				// Torna a la pantalla d'inici (ActivityMain)
				i = new Intent(EditTeamScreen.this, MainActivity.class);
				startActivity(i);	
				break;
		}
	}
}