package com.example.basketballmatchmanager;

import java.util.ArrayList;

import com.example.basketballmatchmanager.db.Item;
import com.example.basketballmatchmanager.db.League;
import com.example.basketballmatchmanager.db.Club;
import com.example.basketballmatchmanager.db.Match;
import com.example.basketballmatchmanager.db.Player;
import com.example.basketballmatchmanager.db.Team;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.Toast;

public class ListItemScreen extends Activity implements OnItemClickListener{
	
	private League myLeague;
	private Club myClub;
	private Team myTeam;
	private Player myPlayer;
	private Match myMatch;
	private Bundle buttonPushedR;
	private TextView ListTittle;
	private ListView TableList;		
	private ArrayAdapter<Item> adaptador ;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
				
		super.onCreate(savedInstanceState);
		setContentView(R.layout.basket_item_list);

		ListTittle = (TextView) findViewById(R.id.lbLstItem);
		TableList = (ListView) findViewById(R.id.listView01);
		buttonPushedR = getIntent().getExtras();
		//int buttonNumber = Integer.parseInt(buttonPushedR.get("buttonPushedKey").toString());
		
		if (buttonPushedR.get("buttonPushedKey").equals("1")){ 
			myLeague = new League (this);
			myLeague.openConnection();
			
			ListTittle.setText(R.string.LlLeagues);
			//Recupera els registres e imprimeix al TableList
			Cursor cursor = myLeague.getRegisters();
			ArrayList<Item> listData = myLeague.getListItem(cursor);
			adaptador = new ArrayAdapter<Item>(this, android.R.layout.simple_list_item_1, listData);
			TableList.setAdapter(adaptador);
			TableList.setOnItemClickListener(this);

			if(listData.size()== 0){
				Toast.makeText(getBaseContext(), "No existen registros", Toast.LENGTH_SHORT).show();
			}
			cursor.close();
			myLeague.closeConnection();
		}
		else if (buttonPushedR.get("buttonPushedKey").equals("2")){ 
			myClub = new Club (this);
			myClub.openConnection();
			
			ListTittle.setText(R.string.LlClubs);
			//Recupera els registres e imprimeix al TableList
			Cursor cursor = myClub.getRegisters();
			ArrayList<Item> listData = myClub.getListItem(cursor);
			adaptador = new ArrayAdapter<Item>(this, android.R.layout.simple_list_item_1, listData);
			TableList.setAdapter(adaptador);
			TableList.setOnItemClickListener(this);

			if(listData.size()== 0){
				Toast.makeText(getBaseContext(), "No existen registros", Toast.LENGTH_SHORT).show();
			}
			cursor.close();
			myClub.closeConnection();
		}
		/*
		else if (buttonPushedR.get("buttonPushedKey").equals("3")){
			
			myTeam = new Team (this);
			myTeam.openConnection();
			
			//Recupera els registres e imprimeix al TableList
			Cursor cursor = myTeam.getRegisters();
			ArrayList<Item> listData = myTeam.getListItem(cursor);
			adaptador = new ArrayAdapter<Item>(this, android.R.layout.simple_list_item_1, listData);
			TableList.setAdapter(adaptador);
			TableList.setOnItemClickListener(this);

			if(listData.size()== 0){
				Toast.makeText(getBaseContext(), "No existen registros", Toast.LENGTH_SHORT).show();
			}
			cursor.close();
			myTeam.closeConnection();
		}*/
		else if (buttonPushedR.get("buttonPushedKey").equals("3")){ 
			
			myPlayer = new Player (this);
			myPlayer.openConnection();
			
			ListTittle.setText(R.string.LlPlayers);
			//Recupera els registres e imprimeix al TableList
			Cursor cursor = myPlayer.getRegisters();
			ArrayList<Item> listData = myPlayer.getListItem(cursor);
			adaptador = new ArrayAdapter<Item>(this, android.R.layout.simple_list_item_1, listData);
			TableList.setAdapter(adaptador);
			TableList.setOnItemClickListener(this);

			if(listData.size()== 0){
				Toast.makeText(getBaseContext(), "No existen registros", Toast.LENGTH_SHORT).show();
			}
			cursor.close();
			myPlayer.closeConnection();
		}		
		else if (buttonPushedR.get("buttonPushedKey").equals("4")){ 
			
			myMatch = new Match (this);
			myMatch.openConnection();
			
			ListTittle.setText(R.string.LlMatches);
			//Recupera els registres e imprimeix al TableList
			Cursor cursor = myMatch.getRegisters();
			ArrayList<Item> listData = myMatch.getListItem(cursor);
			adaptador = new ArrayAdapter<Item>(this, android.R.layout.simple_list_item_1, listData);
			TableList.setAdapter(adaptador);
			TableList.setOnItemClickListener(this);

			if(listData.size()== 0){
				Toast.makeText(getBaseContext(), "No existen registros", Toast.LENGTH_SHORT).show();
			}
			cursor.close();
			myMatch.closeConnection();
		}		
	}

	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position,	long id) {
		// TODO Auto-generated method stub
		
		Object object  = parent.getAdapter().getItem(position);
		String resultado = ((Item)object).getId();
		
		//Executa una nova activitat
		Bundle b = new Bundle();
		b.putInt("id", Integer.valueOf(resultado));
		
		if (buttonPushedR.get("buttonPushedKey").equals("1")){ 
			Intent i = new Intent(ListItemScreen.this, EditLeagueScreen.class );	
			i.putExtras(b);
			startActivity(i);
		}
		else if (buttonPushedR.get("buttonPushedKey").equals("2")){ 
			Intent i = new Intent(ListItemScreen.this, EditClubScreen.class );	
			i.putExtras(b);
			startActivity(i);
		}
		else if (buttonPushedR.get("buttonPushedKey").equals("3")){ 
			Intent i = new Intent(ListItemScreen.this, EditPlayerScreen.class );	
			i.putExtras(b);
			startActivity(i);
		}
		else if (buttonPushedR.get("buttonPushedKey").equals("4")){ 
			Intent i = new Intent(ListItemScreen.this, EditMatchScreen.class );	
			i.putExtras(b);
			startActivity(i);
		}
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

}
