package com.example.basketballmatchmanager.db;

import java.util.ArrayList;
import android.content.Context;
import android.content.ContentValues;
import android.database.Cursor;
import android.util.Log;

public class Player extends SQLiteDBManager {
	
	private int id;
	private String name;
	private String surname;
	private String birth;
	private String sex;
	private Boolean nation;
	private String creationUser;
	private String creationDate;
	
	/** Constructor de classe 1 */
	public Player (Context context) {
		super(context);
	}
	
	/** Constructor de classe 2*/
	public Player (Context context, String name, String surname, String birth, String sex, Boolean nation, String user) {
		
		super (context);
		this.name = name;
		this.surname = surname;
		this.birth = birth;
		this.sex = sex;
		this.nation = nation;
		this.creationUser = user;
		this.creationDate = CurrentDate(); 
	}
	
	/**
	 * Mtode per afegir un nou registre.
	 * @return BOOLEAN TRUE si ha tingut xit FALSE cas contrari
	 * */
	public boolean addRegister() {
		
		if (name.length() > 0) {
			ContentValues contentValues = new ContentValues();
			contentValues.put(DBHelper.CN_NAME, this.name);
			contentValues.put(DBHelper.CN_SURNAME, this.surname);
			contentValues.put(DBHelper.CN_BIRTH, this.birth);
			contentValues.put(DBHelper.CN_SEX, this.sex);
			contentValues.put(DBHelper.CN_NATION, this.nation);
			contentValues.put(DBHelper.CN_USER, this.creationUser);
			contentValues.put(DBHelper.CN_CREATION, this.creationDate);
			Log.i("SQLite", "Intent de enregistrar un equip");
			return (DBObject.insert(DBHelper.TABLE_NAME_PLAYERS, null, contentValues)!=-1)?true:false;
			} 
		else
			return false;
	}
	
	public ArrayList<Item> getListItem(Cursor cursor) {
		 
		ArrayList<Item> listData = new ArrayList<Item>();
		String aux = "";
		
		if (cursor.moveToFirst()) {
			do {
				//aux += "Id: " + cursor.getString(0) + "\r\n";
				aux += "Jugador: " + cursor.getString(2) + ", " + cursor.getString(1) + "\r\n";
				aux += "Neixement: " + cursor.getString(3) + "\r\n";
				aux += "M/F: " + cursor.getString(4) + "\r\n";
				aux += "Pasaport: " + ((Integer.parseInt(cursor.getString(5))==0)?"Nacional":"Internacional");
				Item item = new Item (cursor.getString(0), aux);
				listData.add(item);
				aux = "";
			} while (cursor.moveToNext());
		}
		return listData;
	}
	
	/**
	 * Recupera tots els registres de la taula indicada de la base de dades
	 * @return Cursor
	 * */
	public Cursor getPlayerForId(int id) {
		return DBObject.query(DBHelper.TABLE_NAME_PLAYERS, 
				new String[] {
				DBHelper.CN_ID, 								
				DBHelper.CN_NAME,
				DBHelper.CN_SURNAME,
				DBHelper.CN_BIRTH, 
				DBHelper.CN_SEX,
				DBHelper.CN_NATION,
				DBHelper.CN_USER,
				DBHelper.CN_CREATION}, 
				DBHelper.CN_ID + " = " + id, null, null, null, null);					
	}
		
	/**
	 * Recupera tots els registres de la taula indicada de la base de dades
	 * @return Cursor
	 * */
	public Cursor getRegisters() {
		return DBObject.query(DBHelper.TABLE_NAME_PLAYERS, 
				new String[] {
				DBHelper.CN_ID, 								
				DBHelper.CN_NAME,
				DBHelper.CN_SURNAME,
				DBHelper.CN_BIRTH, 
				DBHelper.CN_SEX,
				DBHelper.CN_NATION,
				DBHelper.CN_USER,
				DBHelper.CN_CREATION}, null, null, null, null, null);					
	}
	
	public String toString() {
		return ("Jugador: " + this.name + "\n");
	}
}
