package com.example.basketballmatchmanager.db;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.example.basketballmatchmanager.db.SQLiteHelper;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

public class SQLiteDBManager {

	protected SQLiteHelper DBHelper;
	protected SQLiteDatabase DBObject;

	/** Constructor de classe */
	public SQLiteDBManager(Context context) {
		DBHelper = new SQLiteHelper(context);		
	}
	
	/** Obre una connexi a la base de dades */
	public void openConnection() {
		Log.i("SQLite", "DataBase Connection Succesful" + DBHelper.getDatabaseName());
		DBObject = DBHelper.getWritableDatabase();
	}
	
	/** Tanca la connexi a la base de dades */
	public void closeConnection() {
		Log.i("SQLite", "DataBase Connection Close" + DBHelper.getDatabaseName());
		DBHelper.close();
	}
	
    /** 
     * Getting laber with conditions
     * returns queryResult 
     * */
    protected String getStringQuery (String selectQuery) {

        Cursor cursor = DBObject.rawQuery(selectQuery, null);//selectQuery,selectedArguments
        String str = "Not Defined";
        if (cursor.moveToFirst()) { str = cursor.getString(0); }  
        cursor.close();  
        DBObject.close();  
        return str;
    	} 
	
    /** 
     * Getting all labels 
     * returns list of labels 
     * */
    protected List<Item> getCursorQuery (String selectQuery, boolean twoFields) {

    	List<Item> list = new ArrayList<Item>();
        Cursor cursor = DBObject.rawQuery(selectQuery, null);//selectQuery,selectedArguments  
   
        // looping through all rows and adding to list  
        if (cursor.moveToFirst()) {  
            do {
            	Item item = new Item(cursor.getString(0),
            			(twoFields)?cursor.getString(1) + " " + cursor.getString(2):cursor.getString(2));
                list.add(item);   
            } while (cursor.moveToNext());  
        }  
        // closing connection  
        cursor.close();  
        DBObject.close();  
        return list;
    	}  

	protected String CurrentDate () {
		Date date = new Date();
		DateFormat dateformat = new SimpleDateFormat ("dd/mm/yyyyy");
		return dateformat.format(date);
	}
}
